Serializer File Reference
`#include <osg/ref_ptr>`
`#include <osg/Notify>`
`#include <osg/Object>`
`#include <osgDB/InputStream>`
`#include <osgDB/OutputStream>`
`#include <string>`
`#include <sstream>`
`#include <limits.h>`

Go to the source code of this file.

## Classes

class | osgDB::IntLookup
class | osgDB::UserLookupTableProxy
class | osgDB::BaseSerializer
class | osgDB::UserSerializer< C >
class | osgDB::TemplateSerializer< P >
class | osgDB::PropByValSerializer< C, P >
class | osgDB::PropByRefSerializer< C, P >
class | osgDB::MatrixSerializer< C >
class | osgDB::GLenumSerializer< C, P >
class | osgDB::StringSerializer< C >
class | osgDB::ObjectSerializer< C, P >
class | osgDB::ImageSerializer< C, P >
class | osgDB::EnumSerializer< C, P, B >
class | osgDB::ListSerializer< C, P >
class | osgDB::VectorBaseSerializer
class | osgDB::VectorSerializer< C, P >
class | osgDB::IsAVectorSerializer< C >
class | osgDB::MapIteratorObject
class | osgDB::MapBaseSerializer
class | osgDB::MapSerializer< C, P >
struct | osgDB::MapSerializer< C, P >::MapIterator
struct | osgDB::MapSerializer< C, P >::ReverseMapIterator
class | osgDB::BitFlagsSerializer< C, P >

## Namespaces

namespace | osgDB

## Macros

#define | OSGDB__SERIALIZER
#define | OBJECT_CAST static_cast
#define | BEGIN_USER_TABLE(NAME, CLASS)
#define | ADD_USER_VALUE(VALUE)
#define | END_USER_TABLE()
#define | USER_READ_FUNC(NAME, FUNCNAME)
#define | USER_WRITE_FUNC(NAME, FUNCNAME)
#define | ADD_SERIALIZER(S)
#define | ADD_USER_SERIALIZER(PROP)
#define | ADD_BOOL_SERIALIZER(PROP, DEF)
#define | ADD_CHAR_SERIALIZER(PROP, DEF)
#define | ADD_UCHAR_SERIALIZER(PROP, DEF)
#define | ADD_SHORT_SERIALIZER(PROP, DEF)
#define | ADD_USHORT_SERIALIZER(PROP, DEF)
#define | ADD_HEXSHORT_SERIALIZER(PROP, DEF)
#define | ADD_INT_SERIALIZER(PROP, DEF)
#define | ADD_INT_SERIALIZER_NO_SET(PROP, DEF)
#define | ADD_UINT_SERIALIZER(PROP, DEF)
#define | ADD_UINT_SERIALIZER_NO_SET(PROP, DEF)
#define | ADD_GLINT_SERIALIZER(PROP, DEF)
#define | ADD_HEXINT_SERIALIZER(PROP, DEF)
#define | ADD_FLOAT_SERIALIZER(PROP, DEF)
#define | ADD_DOUBLE_SERIALIZER(PROP, DEF)
#define | ADD_REF_BOOL_SERIALIZER(PROP, DEF)
#define | ADD_REF_CHAR_SERIALIZER(PROP, DEF)
#define | ADD_REF_UCHAR_SERIALIZER(PROP, DEF)
#define | ADD_REF_SHORT_SERIALIZER(PROP, DEF)
#define | ADD_REF_USHORT_SERIALIZER(PROP, DEF)
#define | ADD_REF_HEXSHORT_SERIALIZER(PROP, DEF)
#define | ADD_REF_INT_SERIALIZER(PROP, DEF)
#define | ADD_REF_UINT_SERIALIZER(PROP, DEF)
#define | ADD_REF_GLINT_SERIALIZER(PROP, DEF)
#define | ADD_REF_HEXINT_SERIALIZER(PROP, DEF)
#define | ADD_REF_FLOAT_SERIALIZER(PROP, DEF)
#define | ADD_REF_DOUBLE_SERIALIZER(PROP, DEF)
#define | ADD_VEC2B_SERIALIZER(PROP, DEF)
#define | ADD_VEC2UB_SERIALIZER(PROP, DEF)
#define | ADD_VEC2S_SERIALIZER(PROP, DEF)
#define | ADD_VEC2US_SERIALIZER(PROP, DEF)
#define | ADD_VEC2I_SERIALIZER(PROP, DEF)
#define | ADD_VEC2UI_SERIALIZER(PROP, DEF)
#define | ADD_VEC2F_SERIALIZER(PROP, DEF)
#define | ADD_VEC2D_SERIALIZER(PROP, DEF)
#define | ADD_VEC2_SERIALIZER(PROP, DEF)
#define | ADD_VEC3B_SERIALIZER(PROP, DEF)
#define | ADD_VEC3UB_SERIALIZER(PROP, DEF)
#define | ADD_VEC3S_SERIALIZER(PROP, DEF)
#define | ADD_VEC3US_SERIALIZER(PROP, DEF)
#define | ADD_VEC3I_SERIALIZER(PROP, DEF)
#define | ADD_VEC3UI_SERIALIZER(PROP, DEF)
#define | ADD_VEC3F_SERIALIZER(PROP, DEF)
#define | ADD_VEC3D_SERIALIZER(PROP, DEF)
#define | ADD_VEC3_SERIALIZER(PROP, DEF)
#define | ADD_VEC4B_SERIALIZER(PROP, DEF)
#define | ADD_VEC4UB_SERIALIZER(PROP, DEF)
#define | ADD_VEC4S_SERIALIZER(PROP, DEF)
#define | ADD_VEC4US_SERIALIZER(PROP, DEF)
#define | ADD_VEC4I_SERIALIZER(PROP, DEF)
#define | ADD_VEC4UI_SERIALIZER(PROP, DEF)
#define | ADD_VEC4F_SERIALIZER(PROP, DEF)
#define | ADD_VEC4D_SERIALIZER(PROP, DEF)
#define | ADD_VEC4_SERIALIZER(PROP, DEF)
#define | ADD_QUAT_SERIALIZER(PROP, DEF)
#define | ADD_PLANE_SERIALIZER(PROP, DEF)
#define | ADD_MATRIXF_SERIALIZER(PROP, DEF)
#define | ADD_MATRIXD_SERIALIZER(PROP, DEF)
#define | ADD_MATRIX_SERIALIZER(PROP, DEF)
#define | ADD_BOUNDINGBOXF_SERIALIZER(PROP, DEF)
#define | ADD_BOUNDINGBOXD_SERIALIZER(PROP, DEF)
#define | ADD_BOUNDINGSPHEREF_SERIALIZER(PROP, DEF)
#define | ADD_BOUNDINGSPHERED_SERIALIZER(PROP, DEF)
#define | ADD_GLENUM_SERIALIZER(PROP, TYPE, DEF)
#define | ADD_GLENUM_SERIALIZER_NO_SET(PROP, TYPE, DEF)
#define | ADD_STRING_SERIALIZER(PROP, DEF)
#define | ADD_OBJECT_SERIALIZER(PROP, TYPE, DEF)
#define | ADD_OBJECT_SERIALIZER_NO_SET(PROP, TYPE, DEF)
#define | ADD_IMAGE_SERIALIZER(PROP, TYPE, DEF)
#define | ADD_LIST_SERIALIZER(PROP, TYPE)
#define | ADD_VECTOR_SERIALIZER(PROP, TYPE, ELEMENTTYPE, NUMELEMENTSONROW)
#define | ADD_ISAVECTOR_SERIALIZER(PROP, ELEMENTTYPE, NUMELEMENTSONROW)
#define | BEGIN_ENUM_SERIALIZER(PROP, DEF)
#define | BEGIN_ENUM_SERIALIZER2(PROP, TYPE, DEF)
#define | BEGIN_ENUM_SERIALIZER3(PROP, DEF)
#define | BEGIN_ENUM_SERIALIZER4(PROPERTIES_CLASS, PROP, DEF)
#define | BEGIN_ENUM_SERIALIZER_NO_SET(PROP, DEF)
#define | ADD_ENUM_VALUE(VALUE)
#define | ADD_ENUM_CLASS_VALUE(CLASS, VALUE)
#define | END_ENUM_SERIALIZER()
#define | BEGIN_BITFLAGS_SERIALIZER(PROP, DEF)
#define | BEGIN_UINT_BITFLAGS_SERIALIZER(PROP, DEF)
#define | BEGIN_INT_BITFLAGS_SERIALIZER(PROP, DEF)
#define | ADD_BITFLAG_VALUE(VALUE_NAME, VALUE)
#define | END_BITFLAGS_SERIALIZER()
#define | UPDATE_TO_VERSION(VER)
#define | UPDATE_TO_VERSION_SCOPED(VER)
#define | ADDED_ASSOCIATE(STR)
#define | REMOVED_ASSOCIATE(STR)
#define | REMOVE_SERIALIZER(PROP)
#define | ADD_MAP_SERIALIZER(PROP, TYPE, KEYTYPE, ELEMENTTYPE)
#define | ADD_METHOD_OBJECT(METHODNAME, METHODOBJECTCLASS)
#define | ADD_METHOD(METHODNAME)
#define | SET_USAGE(VALUE)

## Typedefs

typedef std::vector< std::string > | osgDB::StringList

## Functions

OSGDB_EXPORT void | osgDB::split (const std::string &src, StringList &list, char separator=' ')

## Macro Definition Documentation

## ADD_BITFLAG_VALUE

#define ADD_BITFLAG_VALUE | ( |  | VALUE_NAME,
|  |  | VALUE )

Value:
serializer->add(#VALUE_NAME, VALUE)

## ADD_BOOL_SERIALIZER

#define ADD_BOOL_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, bool >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_BOOL )
osgDB::BaseSerializer::RW_BOOL
@ RW_BOOL
Definition Serializer:147
osgDB::PropByValSerializer
Definition Serializer:273

## ADD_BOUNDINGBOXD_SERIALIZER

#define ADD_BOUNDINGBOXD_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::BoundingBoxd >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_BOUNDINGBOXD )
osgDB::BaseSerializer::RW_BOUNDINGBOXD
@ RW_BOUNDINGBOXD
Definition Serializer:153
osgDB::PropByRefSerializer
Definition Serializer:332

## ADD_BOUNDINGBOXF_SERIALIZER

#define ADD_BOUNDINGBOXF_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::BoundingBoxf >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_BOUNDINGBOXF )
osgDB::BaseSerializer::RW_BOUNDINGBOXF
@ RW_BOUNDINGBOXF
Definition Serializer:153

## ADD_BOUNDINGSPHERED_SERIALIZER

#define ADD_BOUNDINGSPHERED_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::BoundingSphered >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_BOUNDINGSPHERED )
osgDB::BaseSerializer::RW_BOUNDINGSPHERED
@ RW_BOUNDINGSPHERED
Definition Serializer:154

## ADD_BOUNDINGSPHEREF_SERIALIZER

#define ADD_BOUNDINGSPHEREF_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::BoundingSpheref >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_BOUNDINGSPHEREF )
osgDB::BaseSerializer::RW_BOUNDINGSPHEREF
@ RW_BOUNDINGSPHEREF
Definition Serializer:154

## ADD_CHAR_SERIALIZER

#define ADD_CHAR_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, char >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_CHAR )
osgDB::BaseSerializer::RW_CHAR
@ RW_CHAR
Definition Serializer:147

## ADD_DOUBLE_SERIALIZER

#define ADD_DOUBLE_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, double >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_DOUBLE )
osgDB::BaseSerializer::RW_DOUBLE
@ RW_DOUBLE
Definition Serializer:147

## ADD_ENUM_CLASS_VALUE

#define ADD_ENUM_CLASS_VALUE | ( |  | CLASS,
|  |  | VALUE )

Value:
serializer->add(#VALUE, CLASS::VALUE)

## ADD_ENUM_VALUE

#define ADD_ENUM_VALUE | ( |  | VALUE | ) |

Value:
serializer->add(#VALUE, MyClass::VALUE)

## ADD_FLOAT_SERIALIZER

#define ADD_FLOAT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, float >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_FLOAT )
osgDB::BaseSerializer::RW_FLOAT
@ RW_FLOAT
Definition Serializer:147

## ADD_GLENUM_SERIALIZER

#define ADD_GLENUM_SERIALIZER | ( |  | PROP,
|  |  | TYPE,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::GLenumSerializer< MyClass, TYPE >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_GLENUM )
osgDB::BaseSerializer::RW_GLENUM
@ RW_GLENUM
Definition Serializer:149
osgDB::GLenumSerializer
Definition Serializer:453

## ADD_GLENUM_SERIALIZER_NO_SET

#define ADD_GLENUM_SERIALIZER_NO_SET | ( |  | PROP,
|  |  | TYPE,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::GLenumSerializer< MyClass, TYPE >( \
#PROP, DEF, &MyClass::get##PROP, 0), osgDB::BaseSerializer::RW_GLENUM )

## ADD_GLINT_SERIALIZER

#define ADD_GLINT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, GLint >( \
#PROP, ((int)(DEF)), &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_INT )
osgDB::BaseSerializer::RW_INT
@ RW_INT
Definition Serializer:147

## ADD_HEXINT_SERIALIZER

#define ADD_HEXINT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, unsigned int >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP, true), osgDB::BaseSerializer::RW_UINT )
osgDB::BaseSerializer::RW_UINT
@ RW_UINT
Definition Serializer:147

## ADD_HEXSHORT_SERIALIZER

#define ADD_HEXSHORT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, unsigned short >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP, true), osgDB::BaseSerializer::RW_USHORT )
osgDB::BaseSerializer::RW_USHORT
@ RW_USHORT
Definition Serializer:147

## ADD_IMAGE_SERIALIZER

#define ADD_IMAGE_SERIALIZER | ( |  | PROP,
|  |  | TYPE,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::ImageSerializer< MyClass, TYPE >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_IMAGE )
osgDB::BaseSerializer::RW_IMAGE
@ RW_IMAGE
Definition Serializer:146
osgDB::ImageSerializer
Definition Serializer:635

## ADD_INT_SERIALIZER

#define ADD_INT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, int >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_INT )

## ADD_INT_SERIALIZER_NO_SET

#define ADD_INT_SERIALIZER_NO_SET | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, int >( \
#PROP, DEF, &MyClass::get##PROP, 0), osgDB::BaseSerializer::RW_INT )

## ADD_ISAVECTOR_SERIALIZER

#define ADD_ISAVECTOR_SERIALIZER | ( |  | PROP,
|  |  | ELEMENTTYPE,
|  |  | NUMELEMENTSONROW )

Value:
wrapper->addSerializer( new osgDB::IsAVectorSerializer< MyClass >( #PROP, ELEMENTTYPE, NUMELEMENTSONROW), osgDB::BaseSerializer::RW_VECTOR )
osgDB::BaseSerializer::RW_VECTOR
@ RW_VECTOR
Definition Serializer:155
osgDB::IsAVectorSerializer
Definition Serializer:1056

## ADD_LIST_SERIALIZER

#define ADD_LIST_SERIALIZER | ( |  | PROP,
|  |  | TYPE )

Value:
wrapper->addSerializer( new osgDB::ListSerializer< MyClass, TYPE >( \
#PROP, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_LIST )
osgDB::BaseSerializer::RW_LIST
@ RW_LIST
Definition Serializer:146
osgDB::ListSerializer
Definition Serializer:775

## ADD_MAP_SERIALIZER

#define ADD_MAP_SERIALIZER | ( |  | PROP,
|  |  | TYPE,
|  |  | KEYTYPE,
|  |  | ELEMENTTYPE )

Value:
wrapper->addSerializer( new osgDB::MapSerializer< MyClass, TYPE >( \
#PROP, &MyClass::get##PROP, &MyClass::get##PROP, &MyClass::set##PROP, KEYTYPE, ELEMENTTYPE), osgDB::BaseSerializer::RW_MAP )
osgDB::BaseSerializer::RW_MAP
@ RW_MAP
Definition Serializer:155
osgDB::MapSerializer
Definition Serializer:1277

## ADD_MATRIX_SERIALIZER

#define ADD_MATRIX_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::MatrixSerializer< MyClass >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_MATRIX )
osgDB::BaseSerializer::RW_MATRIX
@ RW_MATRIX
Definition Serializer:149
osgDB::MatrixSerializer
Definition Serializer:383

## ADD_MATRIXD_SERIALIZER

#define ADD_MATRIXD_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Matrixd >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_MATRIXD )
osgDB::BaseSerializer::RW_MATRIXD
@ RW_MATRIXD
Definition Serializer:149

## ADD_MATRIXF_SERIALIZER

#define ADD_MATRIXF_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Matrixf >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_MATRIXF )
osgDB::BaseSerializer::RW_MATRIXF
@ RW_MATRIXF
Definition Serializer:149

## ADD_METHOD

#define ADD_METHOD | ( |  | METHODNAME | ) |

Value:
{ \
struct MethodCaller : public osgDB::MethodObject \
{ \
virtual bool run(void* objectPtr, osg::Parameters&, osg::Parameters&) const \
{ \
MyClass* obj = reinterpret_cast<MyClass*>(objectPtr); \
obj->METHODNAME(); \
return true; \
} \
}; \
wrapper->addMethodObject(#METHODNAME, new MethodCaller()); \
}
osg::Parameters
std::vector< osg::ref_ptr< osg::Object > > Parameters
Definition Callback:130
osgDB::MethodObject
Definition ObjectWrapper:26
osgDB::MethodObject::run
virtual bool run(void *objectPtr, osg::Parameters &inputParameters, osg::Parameters &outputParameters) const =0

## ADD_METHOD_OBJECT

#define ADD_METHOD_OBJECT | ( |  | METHODNAME,
|  |  | METHODOBJECTCLASS )

Value:
wrapper->addMethodObject(METHODNAME, new METHODOBJECTCLASS());

## ADD_OBJECT_SERIALIZER

#define ADD_OBJECT_SERIALIZER | ( |  | PROP,
|  |  | TYPE,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::ObjectSerializer< MyClass, TYPE >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_OBJECT )
osgDB::BaseSerializer::RW_OBJECT
@ RW_OBJECT
Definition Serializer:146
osgDB::ObjectSerializer
Definition Serializer:555

## ADD_OBJECT_SERIALIZER_NO_SET

#define ADD_OBJECT_SERIALIZER_NO_SET | ( |  | PROP,
|  |  | TYPE,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::ObjectSerializer< MyClass, TYPE >( \
#PROP, DEF, &MyClass::get##PROP, 0), osgDB::BaseSerializer::RW_OBJECT )

## ADD_PLANE_SERIALIZER

#define ADD_PLANE_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Plane >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_PLANE )
osgDB::BaseSerializer::RW_PLANE
@ RW_PLANE
Definition Serializer:148

## ADD_QUAT_SERIALIZER

#define ADD_QUAT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Quat >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_QUAT )
osgDB::BaseSerializer::RW_QUAT
@ RW_QUAT
Definition Serializer:148

## ADD_REF_BOOL_SERIALIZER

#define ADD_REF_BOOL_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, bool >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_BOOL )

## ADD_REF_CHAR_SERIALIZER

#define ADD_REF_CHAR_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, char >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_CHAR )

## ADD_REF_DOUBLE_SERIALIZER

#define ADD_REF_DOUBLE_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, double >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_DOUBLE )

## ADD_REF_FLOAT_SERIALIZER

#define ADD_REF_FLOAT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, float >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_FLOAT )

## ADD_REF_GLINT_SERIALIZER

#define ADD_REF_GLINT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, GLint >( \
#PROP, ((int)(DEF)), &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_INT )

## ADD_REF_HEXINT_SERIALIZER

#define ADD_REF_HEXINT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, unsigned int >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP, true), osgDB::BaseSerializer::RW_UINT )

## ADD_REF_HEXSHORT_SERIALIZER

#define ADD_REF_HEXSHORT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, unsigned short >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP, true), osgDB::BaseSerializer::RW_USHORT )

## ADD_REF_INT_SERIALIZER

#define ADD_REF_INT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, int >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_INT )

## ADD_REF_SHORT_SERIALIZER

#define ADD_REF_SHORT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, short >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_SHORT )
osgDB::BaseSerializer::RW_SHORT
@ RW_SHORT
Definition Serializer:147

## ADD_REF_UCHAR_SERIALIZER

#define ADD_REF_UCHAR_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, unsigned char >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_UCHAR )
osgDB::BaseSerializer::RW_UCHAR
@ RW_UCHAR
Definition Serializer:147

## ADD_REF_UINT_SERIALIZER

#define ADD_REF_UINT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, unsigned int >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_UINT )

## ADD_REF_USHORT_SERIALIZER

#define ADD_REF_USHORT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, unsigned short >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_USHORT )

## ADD_SERIALIZER

#define ADD_SERIALIZER | ( |  | S | ) |

Value:
wrapper->addSerializer( (S) )

## ADD_SHORT_SERIALIZER

#define ADD_SHORT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, short >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_SHORT )

## ADD_STRING_SERIALIZER

#define ADD_STRING_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::StringSerializer< MyClass >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_STRING )
osgDB::BaseSerializer::RW_STRING
@ RW_STRING
Definition Serializer:149
osgDB::StringSerializer
Definition Serializer:502

## ADD_UCHAR_SERIALIZER

#define ADD_UCHAR_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, unsigned char >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_UCHAR )

## ADD_UINT_SERIALIZER

#define ADD_UINT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, unsigned int >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_UINT )

## ADD_UINT_SERIALIZER_NO_SET

#define ADD_UINT_SERIALIZER_NO_SET | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, unsigned int >( \
#PROP, DEF, &MyClass::get##PROP, 0), osgDB::BaseSerializer::RW_UINT )

## ADD_USER_SERIALIZER

#define ADD_USER_SERIALIZER | ( |  | PROP | ) |

Value:
wrapper->addSerializer( new osgDB::UserSerializer<MyClass>( \
#PROP, &check##PROP, &read##PROP, &write##PROP), osgDB::BaseSerializer::RW_USER )
osgDB::BaseSerializer::RW_USER
@ RW_USER
Definition Serializer:146
osgDB::UserSerializer
Definition Serializer:201

## ADD_USER_VALUE

#define ADD_USER_VALUE | ( |  | VALUE | ) |

Value:
lookup->add(#VALUE, MyClass::VALUE)

## ADD_USHORT_SERIALIZER

#define ADD_USHORT_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByValSerializer< MyClass, unsigned short >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_USHORT )

## ADD_VEC2_SERIALIZER

#define ADD_VEC2_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
ADD_VEC2F_SERIALIZER(PROP, DEF)
ADD_VEC2F_SERIALIZER
#define ADD_VEC2F_SERIALIZER(PROP, DEF)
Definition Serializer:1684

## ADD_VEC2B_SERIALIZER

#define ADD_VEC2B_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2b >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2B )
osgDB::BaseSerializer::RW_VEC2B
@ RW_VEC2B
Definition Serializer:150

## ADD_VEC2D_SERIALIZER

#define ADD_VEC2D_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2d >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2D )
osgDB::BaseSerializer::RW_VEC2D
@ RW_VEC2D
Definition Serializer:148

## ADD_VEC2F_SERIALIZER

#define ADD_VEC2F_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2f >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2F )
osgDB::BaseSerializer::RW_VEC2F
@ RW_VEC2F
Definition Serializer:148

## ADD_VEC2I_SERIALIZER

#define ADD_VEC2I_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2i >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2I )
osgDB::BaseSerializer::RW_VEC2I
@ RW_VEC2I
Definition Serializer:150

## ADD_VEC2S_SERIALIZER

#define ADD_VEC2S_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2s >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2S )
osgDB::BaseSerializer::RW_VEC2S
@ RW_VEC2S
Definition Serializer:150

## ADD_VEC2UB_SERIALIZER

#define ADD_VEC2UB_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2ub >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2UB )
osgDB::BaseSerializer::RW_VEC2UB
@ RW_VEC2UB
Definition Serializer:150

## ADD_VEC2UI_SERIALIZER

#define ADD_VEC2UI_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2ui >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2UI )
osgDB::BaseSerializer::RW_VEC2UI
@ RW_VEC2UI
Definition Serializer:150

## ADD_VEC2US_SERIALIZER

#define ADD_VEC2US_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec2us >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC2US )
osgDB::BaseSerializer::RW_VEC2US
@ RW_VEC2US
Definition Serializer:150

## ADD_VEC3_SERIALIZER

#define ADD_VEC3_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
ADD_VEC3F_SERIALIZER(PROP, DEF)
ADD_VEC3F_SERIALIZER
#define ADD_VEC3F_SERIALIZER(PROP, DEF)
Definition Serializer:1719

## ADD_VEC3B_SERIALIZER

#define ADD_VEC3B_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3b >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3B )
osgDB::BaseSerializer::RW_VEC3B
@ RW_VEC3B
Definition Serializer:151

## ADD_VEC3D_SERIALIZER

#define ADD_VEC3D_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3d >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3D )
osgDB::BaseSerializer::RW_VEC3D
@ RW_VEC3D
Definition Serializer:148

## ADD_VEC3F_SERIALIZER

#define ADD_VEC3F_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3f >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3F )
osgDB::BaseSerializer::RW_VEC3F
@ RW_VEC3F
Definition Serializer:148

## ADD_VEC3I_SERIALIZER

#define ADD_VEC3I_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3i >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3I )
osgDB::BaseSerializer::RW_VEC3I
@ RW_VEC3I
Definition Serializer:151

## ADD_VEC3S_SERIALIZER

#define ADD_VEC3S_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3s >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3S )
osgDB::BaseSerializer::RW_VEC3S
@ RW_VEC3S
Definition Serializer:151

## ADD_VEC3UB_SERIALIZER

#define ADD_VEC3UB_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3ub >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3UB )
osgDB::BaseSerializer::RW_VEC3UB
@ RW_VEC3UB
Definition Serializer:151

## ADD_VEC3UI_SERIALIZER

#define ADD_VEC3UI_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3ui >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3UI )
osgDB::BaseSerializer::RW_VEC3UI
@ RW_VEC3UI
Definition Serializer:151

## ADD_VEC3US_SERIALIZER

#define ADD_VEC3US_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec3us >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC3US )
osgDB::BaseSerializer::RW_VEC3US
@ RW_VEC3US
Definition Serializer:151

## ADD_VEC4_SERIALIZER

#define ADD_VEC4_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
ADD_VEC4F_SERIALIZER(PROP, DEF)
ADD_VEC4F_SERIALIZER
#define ADD_VEC4F_SERIALIZER(PROP, DEF)
Definition Serializer:1753

## ADD_VEC4B_SERIALIZER

#define ADD_VEC4B_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4b >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4B )
osgDB::BaseSerializer::RW_VEC4B
@ RW_VEC4B
Definition Serializer:152

## ADD_VEC4D_SERIALIZER

#define ADD_VEC4D_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4d >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4D )
osgDB::BaseSerializer::RW_VEC4D
@ RW_VEC4D
Definition Serializer:148

## ADD_VEC4F_SERIALIZER

#define ADD_VEC4F_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4f >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4F )
osgDB::BaseSerializer::RW_VEC4F
@ RW_VEC4F
Definition Serializer:148

## ADD_VEC4I_SERIALIZER

#define ADD_VEC4I_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4i >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4I )
osgDB::BaseSerializer::RW_VEC4I
@ RW_VEC4I
Definition Serializer:152

## ADD_VEC4S_SERIALIZER

#define ADD_VEC4S_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4s >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4S )
osgDB::BaseSerializer::RW_VEC4S
@ RW_VEC4S
Definition Serializer:152

## ADD_VEC4UB_SERIALIZER

#define ADD_VEC4UB_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4ub >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4UB )
osgDB::BaseSerializer::RW_VEC4UB
@ RW_VEC4UB
Definition Serializer:152

## ADD_VEC4UI_SERIALIZER

#define ADD_VEC4UI_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4ui >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4UI )
osgDB::BaseSerializer::RW_VEC4UI
@ RW_VEC4UI
Definition Serializer:152

## ADD_VEC4US_SERIALIZER

#define ADD_VEC4US_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
wrapper->addSerializer( new osgDB::PropByRefSerializer< MyClass, osg::Vec4us >( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP), osgDB::BaseSerializer::RW_VEC4US )
osgDB::BaseSerializer::RW_VEC4US
@ RW_VEC4US
Definition Serializer:152

## ADD_VECTOR_SERIALIZER

#define ADD_VECTOR_SERIALIZER | ( |  | PROP,
|  |  | TYPE,
|  |  | ELEMENTTYPE,
|  |  | NUMELEMENTSONROW )

Value:
wrapper->addSerializer( new osgDB::VectorSerializer< MyClass, TYPE >( \
#PROP, &MyClass::get##PROP, &MyClass::get##PROP, &MyClass::set##PROP, ELEMENTTYPE, NUMELEMENTSONROW), osgDB::BaseSerializer::RW_VECTOR )
osgDB::VectorSerializer
Definition Serializer:886

## ADDED_ASSOCIATE

#define ADDED_ASSOCIATE | ( |  | STR | ) |

Value:
wrapper->markAssociateAsAdded( STR );

## BEGIN_BITFLAGS_SERIALIZER

#define BEGIN_BITFLAGS_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::BitFlagsSerializer<MyClass> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP)
osgDB::BitFlagsSerializer
Definition Serializer:1453
osg::ref_ptr
Definition ref_ptr:32

defaults to uint bitfield type.

## BEGIN_ENUM_SERIALIZER

#define BEGIN_ENUM_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::EnumSerializer<MyClass, MyClass::PROP, void> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, MyClass::DEF, &MyClass::get##PROP, &MyClass::set##PROP)
osgDB::EnumSerializer
Definition Serializer:710

## BEGIN_ENUM_SERIALIZER2

#define BEGIN_ENUM_SERIALIZER2 | ( |  | PROP,
|  |  | TYPE,
|  |  | DEF )

Value:
{ typedef osgDB::EnumSerializer<MyClass, TYPE, void> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, MyClass::DEF, &MyClass::get##PROP, &MyClass::set##PROP)

## BEGIN_ENUM_SERIALIZER3

#define BEGIN_ENUM_SERIALIZER3 | ( |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::EnumSerializer<MyClass, MyClass::PROP, bool> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, MyClass::DEF, &MyClass::get##PROP, &MyClass::set##PROP)

## BEGIN_ENUM_SERIALIZER4

#define BEGIN_ENUM_SERIALIZER4 | ( |  | PROPERTIES_CLASS,
|  |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::EnumSerializer<MyClass, PROPERTIES_CLASS::PROP, void> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, PROPERTIES_CLASS::DEF, &MyClass::get##PROP, &MyClass::set##PROP)

## BEGIN_ENUM_SERIALIZER_NO_SET

#define BEGIN_ENUM_SERIALIZER_NO_SET | ( |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::EnumSerializer<MyClass, MyClass::PROP, void> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, MyClass::DEF, &MyClass::get##PROP, 0)

## BEGIN_INT_BITFLAGS_SERIALIZER

#define BEGIN_INT_BITFLAGS_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::BitFlagsSerializer<MyClass, int> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP)

## BEGIN_UINT_BITFLAGS_SERIALIZER

#define BEGIN_UINT_BITFLAGS_SERIALIZER | ( |  | PROP,
|  |  | DEF )

Value:
{ typedef osgDB::BitFlagsSerializer<MyClass, unsigned int> MySerializer; \
osg::ref_ptr<MySerializer> serializer = new MySerializer( \
#PROP, DEF, &MyClass::get##PROP, &MyClass::set##PROP)

## BEGIN_USER_TABLE

#define BEGIN_USER_TABLE | ( |  | NAME,
|  |  | CLASS )

Value:
static void add_user_value_func_##NAME(osgDB::IntLookup*); \
static osgDB::UserLookupTableProxy s_user_lookup_table_##NAME(&add_user_value_func_##NAME); \
static void add_user_value_func_##NAME(osgDB::IntLookup* lookup) { typedef CLASS MyClass
osgDB::IntLookup
Definition Serializer:40
osgDB::UserLookupTableProxy
Definition Serializer:113

## END_BITFLAGS_SERIALIZER

#define END_BITFLAGS_SERIALIZER | ( |  | ) |

Value:
wrapper->addSerializer(serializer.get(), osgDB::BaseSerializer::RW_INT); }

## END_ENUM_SERIALIZER

#define END_ENUM_SERIALIZER | ( |  | ) |

Value:
wrapper->addSerializer(serializer.get(), osgDB::BaseSerializer::RW_ENUM); }
osgDB::BaseSerializer::RW_ENUM
@ RW_ENUM
Definition Serializer:149

## END_USER_TABLE

#define END_USER_TABLE | ( |  | ) |

Value:
}

## OBJECT_CAST

#define OBJECT_CAST static_cast

Referenced by osgDB::IsAVectorSerializer< C >::addElement(), osgDB::VectorSerializer< C, P >::addElement(), osgDB::IsAVectorSerializer< C >::clear(), osgDB::MapSerializer< C, P >::clear(), osgDB::VectorSerializer< C, P >::clear(), osgDB::MapSerializer< C, P >::createIterator(), osgDB::MapSerializer< C, P >::createReverseIterator(), osgDB::ImageSerializer< C, P >::get(), osgDB::ObjectSerializer< C, P >::get(), osgDB::IsAVectorSerializer< C >::getElement(), osgDB::IsAVectorSerializer< C >::getElement(), osgDB::MapSerializer< C, P >::getElement(), osgDB::MapSerializer< C, P >::getElement(), osgDB::VectorSerializer< C, P >::getElement(), osgDB::VectorSerializer< C, P >::getElement(), osgDB::IsAVectorSerializer< C >::insertElement(), osgDB::VectorSerializer< C, P >::insertElement(), osgDB::BitFlagsSerializer< C, P >::read(), osgDB::EnumSerializer< C, P, B >::read(), osgDB::GLenumSerializer< C, P >::read(), osgDB::ImageSerializer< C, P >::read(), osgDB::IsAVectorSerializer< C >::read(), osgDB::ListSerializer< C, P >::read(), osgDB::MapSerializer< C, P >::read(), osgDB::MatrixSerializer< C >::read(), osgDB::ObjectSerializer< C, P >::read(), osgDB::PropByRefSerializer< C, P >::read(), osgDB::PropByValSerializer< C, P >::read(), osgDB::StringSerializer< C >::read(), osgDB::UserSerializer< C >::read(), osgDB::VectorSerializer< C, P >::read(), osgDB::IsAVectorSerializer< C >::reserve(), osgDB::VectorSerializer< C, P >::reserve(), osgDB::IsAVectorSerializer< C >::resize(), osgDB::VectorSerializer< C, P >::resize(), osgDB::ImageSerializer< C, P >::set(), osgDB::ObjectSerializer< C, P >::set(), osgDB::IsAVectorSerializer< C >::setElement(), osgDB::MapSerializer< C, P >::setElement(), osgDB::VectorSerializer< C, P >::setElement(), osgDB::IsAVectorSerializer< C >::size(), osgDB::MapSerializer< C, P >::size(), osgDB::VectorSerializer< C, P >::size(), osgDB::BitFlagsSerializer< C, P >::write(), osgDB::EnumSerializer< C, P, B >::write(), osgDB::GLenumSerializer< C, P >::write(), osgDB::ImageSerializer< C, P >::write(), osgDB::IsAVectorSerializer< C >::write(), osgDB::ListSerializer< C, P >::write(), osgDB::MapSerializer< C, P >::write(), osgDB::MatrixSerializer< C >::write(), osgDB::ObjectSerializer< C, P >::write(), osgDB::PropByRefSerializer< C, P >::write(), osgDB::PropByValSerializer< C, P >::write(), osgDB::StringSerializer< C >::write(), osgDB::UserSerializer< C >::write(), and osgDB::VectorSerializer< C, P >::write().

## OSGDB__SERIALIZER

#define OSGDB__SERIALIZER

## REMOVE_SERIALIZER

#define REMOVE_SERIALIZER | ( |  | PROP | ) |

Value:
wrapper->markSerializerAsRemoved( #PROP );

## REMOVED_ASSOCIATE

#define REMOVED_ASSOCIATE | ( |  | STR | ) |

Value:
wrapper->markAssociateAsRemoved( STR );

## SET_USAGE

#define SET_USAGE | ( |  | VALUE | ) |

Value:
wrapper->getLastSerializer()->setUsage(VALUE)

## UPDATE_TO_VERSION

#define UPDATE_TO_VERSION | ( |  | VER | ) |

Value:
wrapper->setUpdatedVersion( (VER) );

## UPDATE_TO_VERSION_SCOPED

#define UPDATE_TO_VERSION_SCOPED | ( |  | VER | ) |

Value:
osgDB::UpdateWrapperVersionProxy uwvp(wrapper, (VER));
osgDB::UpdateWrapperVersionProxy
Definition ObjectWrapper:138

## USER_READ_FUNC

#define USER_READ_FUNC | ( |  | NAME,
|  |  | FUNCNAME )

Value:
static int FUNCNAME(osgDB::InputStream& is) { \
int value; if (is.isBinary()) is >> value; \
else { std::string str; is >> str; \
value = (s_user_lookup_table_##NAME)._lookup.getValue(str.c_str()); } \
return value; }
osgDB::InputStream
Definition InputStream:64
osgDB::InputStream::isBinary
bool isBinary() const
Definition InputStream:83

## USER_WRITE_FUNC

#define USER_WRITE_FUNC | ( |  | NAME,
|  |  | FUNCNAME )

Value:
static void FUNCNAME(osgDB::OutputStream& os, int value) { \
if (os.isBinary()) os << value; \
else os << (s_user_lookup_table_##NAME)._lookup.getString(value); } \
osgDB::OutputStream
Definition OutputStream:57
osgDB::OutputStream::isBinary
bool isBinary() const
Definition OutputStream:85